% out = sgdPhysics(stepSizeChoice, estimatorChoice, nIter, userBatch, nOfExperiments, nUser,xi0,nu0)
niter = 2000;
userBatch = 10;
nOfExperiments = 250;
nUser = 50;
xi0 = 0.5; nu0 = 0.1;
FCStr = [.8 .5 .4 0.1];
plotRate = 10;
detThresholdParam = 0;

UserStr = [.9 .15 .9 .15];
[out11,out12,out13,out14,out15,out16,out17] = sgdPhysics_v2(plotRate,0, 1, niter, userBatch, nOfExperiments, nUser, xi0,nu0,FCStr,UserStr, detThresholdParam,'Extortion and Stubborn');
 
UserStr = [.9 .9 .15 .15];
[out21,out22,out23,out24,out25,out26,out27]  = sgdPhysics_v2(plotRate,0, 1, niter, userBatch, nOfExperiments, nUser, xi0,nu0,FCStr,UserStr,detThresholdParam, 'Extortion and Tit-for-tat');

UserStr = [.9 .15 .15 .9];
[out31,out32,out33,out34,out35,out36,out37]= sgdPhysics_v2(plotRate,0, 1, niter, userBatch, nOfExperiments, nUser, xi0,nu0,FCStr,UserStr,detThresholdParam, 'Extortion and Pavlov');

UserStr = [.5 .5 .5 .5];
[out41,out42,out43,out44,out45,out46,out47] = sgdPhysics_v2(plotRate,0, 1, niter, userBatch, nOfExperiments, nUser, xi0,nu0,FCStr,UserStr, detThresholdParam,'Equalizer and Coin Toss');

UserStr = [.9 .9 .9 .9];
[out51,out52,out53,out54,out55,out56,out57] = sgdPhysics_v2(plotRate,0, 1, niter, userBatch, nOfExperiments, nUser, xi0,nu0,FCStr,UserStr,detThresholdParam,'Equalizer and Full Coop');

figure, plot(1:plotRate:niter, out11, 1:plotRate:niter, out21, 1:plotRate:niter, out31, 1:plotRate:niter, out41, 1:plotRate:niter, out51,'LineWidth', 1.5);
ylabel('log(Optimality Gap)','Interpreter', 'latex')
xlabel('Iterations','Interpreter', 'latex')
set(gca, 'FontSize', 12);
set(gcf,'color','w');
legend('Stubborn', 'Tit-For-Tat', 'Pavlov','Coin Toss','Full Coop')
grid on

figure, plot(1:plotRate:niter, out14, 1:plotRate:niter, out24, 1:plotRate:niter, out34, 1:plotRate:niter, out44, 1:plotRate:niter, out54,'LineWidth', 1.5);
ylabel('Prob. of User Cooperation $(\tilde{\Lambda}_t \mathbf{q}^\top)$','Interpreter', 'latex')
xlabel('Iterations','Interpreter', 'latex')
set(gca, 'FontSize', 12);
set(gcf,'color','w');
legend('Stubborn', 'Tit-For-Tat', 'Pavlov','Coin Toss','Full Coop')
grid on

figure, plot(1:plotRate:niter, out17, 1:plotRate:niter, out27, 1:plotRate:niter, out37, 1:plotRate:niter, out47, 1:plotRate:niter, out57,'LineWidth', 1.5);
ylabel('User Payoff','Interpreter', 'latex')
xlabel('Iterations','Interpreter', 'latex')
set(gca, 'FontSize', 12);
set(gcf,'color','w');
legend('Stubborn', 'Tit-For-Tat', 'Pavlov','Coin Toss','Full Coop')
grid on