from __future__ import absolute_import, division, print_function, unicode_literals
import numpy as np
from shutil import copyfile
import os
import csv


folder_name = '/Average_'
file = open("input_txt.txt", "r")  # figure_setup.txt, figure_setup_cum_loss.txt
k = 0
file = file.read().splitlines()
for line in file:
    fields = line.split(";")
    if k == 0:
        iteration_files = fields
    elif k == 1:
        value_files = fields
    k += 1

y = []
cost_name = os.path.split(value_files[0])[-1]
main_folder = os.path.split(value_files[0])[0].split('/')[0]
file_name = main_folder + folder_name
for i in range(0, len(value_files)):
    folder_ind = os.path.split(value_files[i])[0].split('/')[-1].split('_')[-1]
    file_name += folder_ind + '_'
    data = []
    iters = []
    data_file = open(value_files[i], "r")
    for data_line in csv.reader(data_file, delimiter=','):
        for col in data_line:
            data.append(float(col))
            # Check if nan
            if data[-1] != data[-1]:
                data[-1] = 1
    data_file.close()
    y.append(np.asarray(data, dtype='float64'))
y = np.array(y)
sum_y = sum(y, 0) / len(y)
sum_y = sum_y.tolist()
if not os.path.exists(file_name):
    os.mkdir(file_name)
val_file_name = file_name + '/' + cost_name

for ii in range(len(sum_y)):
    if not os.path.exists(val_file_name):
        f = open(val_file_name, "w+")
        f.write(str(sum_y[ii]))
        f.close()
    else:
        f = open(val_file_name, "a")
        f.write(',' + str(sum_y[ii]))
        f.close()

iter_file_name = file_name + '/iterations.txt'
copyfile(iteration_files[0], iter_file_name)
